#include		<stdio.h>
#include		<conio.h>

#define		BIO			0x300	//T104-C160 Base Address
											/* PCC160  Address */
#define		COM1			BIO + 0x00
#define		DAT1_1			BIO + 0x01
#define		DAT1_2			BIO + 0x02
#define		DAT1_3			BIO + 0x03

#define		COM2			BIO + 0x04
#define		DAT2_1			BIO + 0x05
#define		DAT2_2			BIO + 0x06
#define		DAT2_3			BIO + 0x07

void main(void)
{
							//
	//outportb(COM1,0xe);   // A1,B1 Level CLR
	outportb(COM1,0xf);     // A1,B1 Edge CLR
	outportb(COM1,0x11);	// A1 2-Phase x1 Mode 
	outportb(COM1,0x19);	// B1 2-Phase x1 Mode

	//outportb(COM2,0xe);   // A2,B2 Level CLR
	outportb(COM2,0xf);     // A2,B2 Edge CLR
	outportb(COM2,0x11);	// A2 2-Phase x1 Mode 
	outportb(COM2,0x19);	// B2 2-Phase x1 Mode

	outportb(DAT1_1,0x12);
	outportb(DAT1_2,0x34);
	outportb(DAT1_3,0x56);
	outportb(COM1,0x00);	//Counter A1 Write
		
	outportb(DAT1_1,0x78);
	outportb(DAT1_2,0x9a);
	outportb(DAT1_3,0xbc);
	outportb(COM1,0x02);	//Counter B1 Write	
	
	outportb(DAT2_1,0xde);
	outportb(DAT2_2,0xf0);
	outportb(DAT2_3,0x12);
	outportb(COM2,0x00);	//Counter A2 Write
	
	outportb(DAT2_1,0x34);
	outportb(DAT2_2,0x56);
	outportb(DAT2_3,0x78);
	outportb(COM2,0x02);	//Counter B2 Write
	

	while(!kbhit()){
		outportb(COM1,0x4);	//Counter A1 Read	
		printf("A1:%02X%02X%02X ",inportb(DAT1_1),inportb(DAT1_2),inportb(DAT1_3) );
		
		outportb(COM1,0x6);	//Counter B1 Read	
		printf("B1:%02X%02X%02X ",inportb(DAT1_1),inportb(DAT1_2),inportb(DAT1_3) );
		
		outportb(COM2,0x4);	//Counter A2 Read	
		printf("A2:%02X%02X%02X ",inportb(DAT2_1),inportb(DAT2_2),inportb(DAT2_3) );
		
		outportb(COM2,0x6);	//Counter B2 Read	
		printf("B2:%02X%02X%02X \n",inportb(DAT2_1),inportb(DAT2_2),inportb(DAT2_3) );
	}
}